# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetPersonalFolderResult',
    'AwaitableGetPersonalFolderResult',
    'get_personal_folder',
    'get_personal_folder_output',
]

@pulumi.output_type
class GetPersonalFolderResult:
    """
    A collection of values returned by getPersonalFolder.
    """
    def __init__(__self__, description=None, id=None, name=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def description(self) -> str:
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        return pulumi.get(self, "name")


class AwaitableGetPersonalFolderResult(GetPersonalFolderResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPersonalFolderResult(
            description=self.description,
            id=self.id,
            name=self.name)


def get_personal_folder(description: Optional[str] = None,
                        id: Optional[str] = None,
                        name: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPersonalFolderResult:
    """
    Provides an easy way to retrieve the Personal Folder.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sumologic as sumologic

    personal_folder = sumologic.get_personal_folder()
    ```

    ## Attributes reference

    The following attributes are exported:

    - `id` - The ID of the Personal Folder.
    - `name` - The name of the Personal Folder.
    - `description` - The description of the Personal Folder.
    """
    __args__ = dict()
    __args__['description'] = description
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('sumologic:index/getPersonalFolder:getPersonalFolder', __args__, opts=opts, typ=GetPersonalFolderResult).value

    return AwaitableGetPersonalFolderResult(
        description=pulumi.get(__ret__, 'description'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_personal_folder_output(description: Optional[pulumi.Input[Optional[str]]] = None,
                               id: Optional[pulumi.Input[Optional[str]]] = None,
                               name: Optional[pulumi.Input[Optional[str]]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPersonalFolderResult]:
    """
    Provides an easy way to retrieve the Personal Folder.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_sumologic as sumologic

    personal_folder = sumologic.get_personal_folder()
    ```

    ## Attributes reference

    The following attributes are exported:

    - `id` - The ID of the Personal Folder.
    - `name` - The name of the Personal Folder.
    - `description` - The description of the Personal Folder.
    """
    __args__ = dict()
    __args__['description'] = description
    __args__['id'] = id
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('sumologic:index/getPersonalFolder:getPersonalFolder', __args__, opts=opts, typ=GetPersonalFolderResult)
    return __ret__.apply(lambda __response__: GetPersonalFolderResult(
        description=pulumi.get(__response__, 'description'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
